<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FecharOrdemServico StructType
 * @subpackage Structs
 */
class FecharOrdemServico extends AbstractStructBase
{
    /**
     * The fechamento
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $fechamento;
    /**
     * The versaoDMS
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $versaoDMS;
    /**
     * The versaoSoft
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $versaoSoft;
    /**
     * Constructor method for FecharOrdemServico
     * @uses FecharOrdemServico::setFechamento()
     * @uses FecharOrdemServico::setVersaoDMS()
     * @uses FecharOrdemServico::setVersaoSoft()
     * @param string $fechamento
     * @param string $versaoDMS
     * @param string $versaoSoft
     */
    public function __construct($fechamento = null, $versaoDMS = null, $versaoSoft = null)
    {
        $this
            ->setFechamento($fechamento)
            ->setVersaoDMS($versaoDMS)
            ->setVersaoSoft($versaoSoft);
    }
    /**
     * Get fechamento value
     * @return string|null
     */
    public function getFechamento()
    {
        return $this->fechamento;
    }
    /**
     * Set fechamento value
     * @param string $fechamento
     * @return \StructType\FecharOrdemServico
     */
    public function setFechamento($fechamento = null)
    {
        // validation for constraint: string
        if (!is_null($fechamento) && !is_string($fechamento)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fechamento, true), gettype($fechamento)), __LINE__);
        }
        $this->fechamento = $fechamento;
        return $this;
    }
    /**
     * Get versaoDMS value
     * @return string|null
     */
    public function getVersaoDMS()
    {
        return $this->versaoDMS;
    }
    /**
     * Set versaoDMS value
     * @param string $versaoDMS
     * @return \StructType\FecharOrdemServico
     */
    public function setVersaoDMS($versaoDMS = null)
    {
        // validation for constraint: string
        if (!is_null($versaoDMS) && !is_string($versaoDMS)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($versaoDMS, true), gettype($versaoDMS)), __LINE__);
        }
        $this->versaoDMS = $versaoDMS;
        return $this;
    }
    /**
     * Get versaoSoft value
     * @return string|null
     */
    public function getVersaoSoft()
    {
        return $this->versaoSoft;
    }
    /**
     * Set versaoSoft value
     * @param string $versaoSoft
     * @return \StructType\FecharOrdemServico
     */
    public function setVersaoSoft($versaoSoft = null)
    {
        // validation for constraint: string
        if (!is_null($versaoSoft) && !is_string($versaoSoft)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($versaoSoft, true), gettype($versaoSoft)), __LINE__);
        }
        $this->versaoSoft = $versaoSoft;
        return $this;
    }
}
